from boto3 import client

__REGION__ = 'us-east-1'


def set_region(region):
    global __REGION__

    __REGION__ = region


def get_user_tags(username: str, region=__REGION__, aws_access_key_id=None, aws_secret_access_key=None):
    iam = client(
        'iam',
        region_name=region,
        aws_access_key_id=aws_access_key_id,
        aws_secret_access_key=aws_secret_access_key
    )

    try:
        user = iam.get_user(UserName=username)
        return user.get('User', {}).get('Tags')
    except iam.exceptions.NoSuchEntityException as e:
        return None


def get_user_tag(username: str, tag: str, region=__REGION__, aws_access_key_id=None, aws_secret_access_key=None):
    tags = get_user_tags(
        username=username,
        region=region,
        aws_access_key_id=aws_access_key_id,
        aws_secret_access_key=aws_secret_access_key
    ) or {}

    matching_tags = [t['Value'] for t in tags if t['Key'] == tag]

    # There are either no matches, or only one...
    if matching_tags:
        return matching_tags[0]
    else:
        return None


if __name__ == '__main__':
    tags = get_user_tag('jeff_carey', 'slack_id', aws_access_key_id="AKIAVJBWZ7VY3SDHOIV3", aws_secret_access_key="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")
    print(tags)
